<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEArchiveReconciliationInvoices ArrayType
 * @subpackage Arrays
 */
class ArrayOfEArchiveReconciliationInvoices extends AbstractStructArrayBase
{
    /**
     * The eArchiveReconciliationInvoices
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EArchiveReconciliationInvoices[]
     */
    public $eArchiveReconciliationInvoices;
    /**
     * Constructor method for ArrayOfEArchiveReconciliationInvoices
     * @uses ArrayOfEArchiveReconciliationInvoices::setEArchiveReconciliationInvoices()
     * @param \StructType\EArchiveReconciliationInvoices[] $eArchiveReconciliationInvoices
     */
    public function __construct(array $eArchiveReconciliationInvoices = array())
    {
        $this
            ->setEArchiveReconciliationInvoices($eArchiveReconciliationInvoices);
    }
    /**
     * Get eArchiveReconciliationInvoices value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EArchiveReconciliationInvoices[]|null
     */
    public function getEArchiveReconciliationInvoices()
    {
        return isset($this->eArchiveReconciliationInvoices) ? $this->eArchiveReconciliationInvoices : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEArchiveReconciliationInvoices method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEArchiveReconciliationInvoices method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEArchiveReconciliationInvoicesForArrayConstraintsFromSetEArchiveReconciliationInvoices(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEArchiveReconciliationInvoicesEArchiveReconciliationInvoicesItem) {
            // validation for constraint: itemType
            if (!$arrayOfEArchiveReconciliationInvoicesEArchiveReconciliationInvoicesItem instanceof \StructType\EArchiveReconciliationInvoices) {
                $invalidValues[] = is_object($arrayOfEArchiveReconciliationInvoicesEArchiveReconciliationInvoicesItem) ? get_class($arrayOfEArchiveReconciliationInvoicesEArchiveReconciliationInvoicesItem) : sprintf('%s(%s)', gettype($arrayOfEArchiveReconciliationInvoicesEArchiveReconciliationInvoicesItem), var_export($arrayOfEArchiveReconciliationInvoicesEArchiveReconciliationInvoicesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The eArchiveReconciliationInvoices property can only contain items of type \StructType\EArchiveReconciliationInvoices, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set eArchiveReconciliationInvoices value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EArchiveReconciliationInvoices[] $eArchiveReconciliationInvoices
     * @return \ArrayType\ArrayOfEArchiveReconciliationInvoices
     */
    public function setEArchiveReconciliationInvoices(array $eArchiveReconciliationInvoices = array())
    {
        // validation for constraint: array
        if ('' !== ($eArchiveReconciliationInvoicesArrayErrorMessage = self::validateEArchiveReconciliationInvoicesForArrayConstraintsFromSetEArchiveReconciliationInvoices($eArchiveReconciliationInvoices))) {
            throw new \InvalidArgumentException($eArchiveReconciliationInvoicesArrayErrorMessage, __LINE__);
        }
        if (is_null($eArchiveReconciliationInvoices) || (is_array($eArchiveReconciliationInvoices) && empty($eArchiveReconciliationInvoices))) {
            unset($this->eArchiveReconciliationInvoices);
        } else {
            $this->eArchiveReconciliationInvoices = $eArchiveReconciliationInvoices;
        }
        return $this;
    }
    /**
     * Add item to eArchiveReconciliationInvoices value
     * @throws \InvalidArgumentException
     * @param \StructType\EArchiveReconciliationInvoices $item
     * @return \ArrayType\ArrayOfEArchiveReconciliationInvoices
     */
    public function addToEArchiveReconciliationInvoices(\StructType\EArchiveReconciliationInvoices $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EArchiveReconciliationInvoices) {
            throw new \InvalidArgumentException(sprintf('The eArchiveReconciliationInvoices property can only contain items of type \StructType\EArchiveReconciliationInvoices, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->eArchiveReconciliationInvoices[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EArchiveReconciliationInvoices|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EArchiveReconciliationInvoices|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EArchiveReconciliationInvoices|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EArchiveReconciliationInvoices|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EArchiveReconciliationInvoices|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string eArchiveReconciliationInvoices
     */
    public function getAttributeName()
    {
        return 'eArchiveReconciliationInvoices';
    }
}
