<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEArchiveReportResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfEArchiveReportResult extends AbstractStructArrayBase
{
    /**
     * The EArchiveReportResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EArchiveReportResult[]
     */
    public $EArchiveReportResult;
    /**
     * Constructor method for ArrayOfEArchiveReportResult
     * @uses ArrayOfEArchiveReportResult::setEArchiveReportResult()
     * @param \StructType\EArchiveReportResult[] $eArchiveReportResult
     */
    public function __construct(array $eArchiveReportResult = array())
    {
        $this
            ->setEArchiveReportResult($eArchiveReportResult);
    }
    /**
     * Get EArchiveReportResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EArchiveReportResult[]|null
     */
    public function getEArchiveReportResult()
    {
        return isset($this->EArchiveReportResult) ? $this->EArchiveReportResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEArchiveReportResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEArchiveReportResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEArchiveReportResultForArrayConstraintsFromSetEArchiveReportResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEArchiveReportResultEArchiveReportResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfEArchiveReportResultEArchiveReportResultItem instanceof \StructType\EArchiveReportResult) {
                $invalidValues[] = is_object($arrayOfEArchiveReportResultEArchiveReportResultItem) ? get_class($arrayOfEArchiveReportResultEArchiveReportResultItem) : sprintf('%s(%s)', gettype($arrayOfEArchiveReportResultEArchiveReportResultItem), var_export($arrayOfEArchiveReportResultEArchiveReportResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EArchiveReportResult property can only contain items of type \StructType\EArchiveReportResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EArchiveReportResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EArchiveReportResult[] $eArchiveReportResult
     * @return \ArrayType\ArrayOfEArchiveReportResult
     */
    public function setEArchiveReportResult(array $eArchiveReportResult = array())
    {
        // validation for constraint: array
        if ('' !== ($eArchiveReportResultArrayErrorMessage = self::validateEArchiveReportResultForArrayConstraintsFromSetEArchiveReportResult($eArchiveReportResult))) {
            throw new \InvalidArgumentException($eArchiveReportResultArrayErrorMessage, __LINE__);
        }
        if (is_null($eArchiveReportResult) || (is_array($eArchiveReportResult) && empty($eArchiveReportResult))) {
            unset($this->EArchiveReportResult);
        } else {
            $this->EArchiveReportResult = $eArchiveReportResult;
        }
        return $this;
    }
    /**
     * Add item to EArchiveReportResult value
     * @throws \InvalidArgumentException
     * @param \StructType\EArchiveReportResult $item
     * @return \ArrayType\ArrayOfEArchiveReportResult
     */
    public function addToEArchiveReportResult(\StructType\EArchiveReportResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EArchiveReportResult) {
            throw new \InvalidArgumentException(sprintf('The EArchiveReportResult property can only contain items of type \StructType\EArchiveReportResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EArchiveReportResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EArchiveReportResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EArchiveReportResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EArchiveReportResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EArchiveReportResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EArchiveReportResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EArchiveReportResult
     */
    public function getAttributeName()
    {
        return 'EArchiveReportResult';
    }
}
