<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEInvoiceCustomerResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfEInvoiceCustomerResult extends AbstractStructArrayBase
{
    /**
     * The EInvoiceCustomerResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EInvoiceCustomerResult[]
     */
    public $EInvoiceCustomerResult;
    /**
     * Constructor method for ArrayOfEInvoiceCustomerResult
     * @uses ArrayOfEInvoiceCustomerResult::setEInvoiceCustomerResult()
     * @param \StructType\EInvoiceCustomerResult[] $eInvoiceCustomerResult
     */
    public function __construct(array $eInvoiceCustomerResult = array())
    {
        $this
            ->setEInvoiceCustomerResult($eInvoiceCustomerResult);
    }
    /**
     * Get EInvoiceCustomerResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EInvoiceCustomerResult[]|null
     */
    public function getEInvoiceCustomerResult()
    {
        return isset($this->EInvoiceCustomerResult) ? $this->EInvoiceCustomerResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEInvoiceCustomerResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEInvoiceCustomerResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEInvoiceCustomerResultForArrayConstraintsFromSetEInvoiceCustomerResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEInvoiceCustomerResultEInvoiceCustomerResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfEInvoiceCustomerResultEInvoiceCustomerResultItem instanceof \StructType\EInvoiceCustomerResult) {
                $invalidValues[] = is_object($arrayOfEInvoiceCustomerResultEInvoiceCustomerResultItem) ? get_class($arrayOfEInvoiceCustomerResultEInvoiceCustomerResultItem) : sprintf('%s(%s)', gettype($arrayOfEInvoiceCustomerResultEInvoiceCustomerResultItem), var_export($arrayOfEInvoiceCustomerResultEInvoiceCustomerResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EInvoiceCustomerResult property can only contain items of type \StructType\EInvoiceCustomerResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EInvoiceCustomerResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EInvoiceCustomerResult[] $eInvoiceCustomerResult
     * @return \ArrayType\ArrayOfEInvoiceCustomerResult
     */
    public function setEInvoiceCustomerResult(array $eInvoiceCustomerResult = array())
    {
        // validation for constraint: array
        if ('' !== ($eInvoiceCustomerResultArrayErrorMessage = self::validateEInvoiceCustomerResultForArrayConstraintsFromSetEInvoiceCustomerResult($eInvoiceCustomerResult))) {
            throw new \InvalidArgumentException($eInvoiceCustomerResultArrayErrorMessage, __LINE__);
        }
        if (is_null($eInvoiceCustomerResult) || (is_array($eInvoiceCustomerResult) && empty($eInvoiceCustomerResult))) {
            unset($this->EInvoiceCustomerResult);
        } else {
            $this->EInvoiceCustomerResult = $eInvoiceCustomerResult;
        }
        return $this;
    }
    /**
     * Add item to EInvoiceCustomerResult value
     * @throws \InvalidArgumentException
     * @param \StructType\EInvoiceCustomerResult $item
     * @return \ArrayType\ArrayOfEInvoiceCustomerResult
     */
    public function addToEInvoiceCustomerResult(\StructType\EInvoiceCustomerResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EInvoiceCustomerResult) {
            throw new \InvalidArgumentException(sprintf('The EInvoiceCustomerResult property can only contain items of type \StructType\EInvoiceCustomerResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EInvoiceCustomerResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EInvoiceCustomerResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EInvoiceCustomerResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EInvoiceCustomerResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EInvoiceCustomerResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EInvoiceCustomerResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EInvoiceCustomerResult
     */
    public function getAttributeName()
    {
        return 'EInvoiceCustomerResult';
    }
}
