<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEarchiveInvoiceCount ArrayType
 * @subpackage Arrays
 */
class ArrayOfEarchiveInvoiceCount extends AbstractStructArrayBase
{
    /**
     * The EarchiveInvoiceCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EarchiveInvoiceCount[]
     */
    public $EarchiveInvoiceCount;
    /**
     * Constructor method for ArrayOfEarchiveInvoiceCount
     * @uses ArrayOfEarchiveInvoiceCount::setEarchiveInvoiceCount()
     * @param \StructType\EarchiveInvoiceCount[] $earchiveInvoiceCount
     */
    public function __construct(array $earchiveInvoiceCount = array())
    {
        $this
            ->setEarchiveInvoiceCount($earchiveInvoiceCount);
    }
    /**
     * Get EarchiveInvoiceCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EarchiveInvoiceCount[]|null
     */
    public function getEarchiveInvoiceCount()
    {
        return isset($this->EarchiveInvoiceCount) ? $this->EarchiveInvoiceCount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEarchiveInvoiceCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEarchiveInvoiceCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEarchiveInvoiceCountForArrayConstraintsFromSetEarchiveInvoiceCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEarchiveInvoiceCountEarchiveInvoiceCountItem) {
            // validation for constraint: itemType
            if (!$arrayOfEarchiveInvoiceCountEarchiveInvoiceCountItem instanceof \StructType\EarchiveInvoiceCount) {
                $invalidValues[] = is_object($arrayOfEarchiveInvoiceCountEarchiveInvoiceCountItem) ? get_class($arrayOfEarchiveInvoiceCountEarchiveInvoiceCountItem) : sprintf('%s(%s)', gettype($arrayOfEarchiveInvoiceCountEarchiveInvoiceCountItem), var_export($arrayOfEarchiveInvoiceCountEarchiveInvoiceCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EarchiveInvoiceCount property can only contain items of type \StructType\EarchiveInvoiceCount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EarchiveInvoiceCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EarchiveInvoiceCount[] $earchiveInvoiceCount
     * @return \ArrayType\ArrayOfEarchiveInvoiceCount
     */
    public function setEarchiveInvoiceCount(array $earchiveInvoiceCount = array())
    {
        // validation for constraint: array
        if ('' !== ($earchiveInvoiceCountArrayErrorMessage = self::validateEarchiveInvoiceCountForArrayConstraintsFromSetEarchiveInvoiceCount($earchiveInvoiceCount))) {
            throw new \InvalidArgumentException($earchiveInvoiceCountArrayErrorMessage, __LINE__);
        }
        if (is_null($earchiveInvoiceCount) || (is_array($earchiveInvoiceCount) && empty($earchiveInvoiceCount))) {
            unset($this->EarchiveInvoiceCount);
        } else {
            $this->EarchiveInvoiceCount = $earchiveInvoiceCount;
        }
        return $this;
    }
    /**
     * Add item to EarchiveInvoiceCount value
     * @throws \InvalidArgumentException
     * @param \StructType\EarchiveInvoiceCount $item
     * @return \ArrayType\ArrayOfEarchiveInvoiceCount
     */
    public function addToEarchiveInvoiceCount(\StructType\EarchiveInvoiceCount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EarchiveInvoiceCount) {
            throw new \InvalidArgumentException(sprintf('The EarchiveInvoiceCount property can only contain items of type \StructType\EarchiveInvoiceCount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EarchiveInvoiceCount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EarchiveInvoiceCount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EarchiveInvoiceCount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EarchiveInvoiceCount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EarchiveInvoiceCount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EarchiveInvoiceCount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EarchiveInvoiceCount
     */
    public function getAttributeName()
    {
        return 'EarchiveInvoiceCount';
    }
}
