<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEnvelopeStateResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfEnvelopeStateResult extends AbstractStructArrayBase
{
    /**
     * The EnvelopeStateResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EnvelopeStateResult[]
     */
    public $EnvelopeStateResult;
    /**
     * Constructor method for ArrayOfEnvelopeStateResult
     * @uses ArrayOfEnvelopeStateResult::setEnvelopeStateResult()
     * @param \StructType\EnvelopeStateResult[] $envelopeStateResult
     */
    public function __construct(array $envelopeStateResult = array())
    {
        $this
            ->setEnvelopeStateResult($envelopeStateResult);
    }
    /**
     * Get EnvelopeStateResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EnvelopeStateResult[]|null
     */
    public function getEnvelopeStateResult()
    {
        return isset($this->EnvelopeStateResult) ? $this->EnvelopeStateResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEnvelopeStateResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEnvelopeStateResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEnvelopeStateResultForArrayConstraintsFromSetEnvelopeStateResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEnvelopeStateResultEnvelopeStateResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfEnvelopeStateResultEnvelopeStateResultItem instanceof \StructType\EnvelopeStateResult) {
                $invalidValues[] = is_object($arrayOfEnvelopeStateResultEnvelopeStateResultItem) ? get_class($arrayOfEnvelopeStateResultEnvelopeStateResultItem) : sprintf('%s(%s)', gettype($arrayOfEnvelopeStateResultEnvelopeStateResultItem), var_export($arrayOfEnvelopeStateResultEnvelopeStateResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EnvelopeStateResult property can only contain items of type \StructType\EnvelopeStateResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EnvelopeStateResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EnvelopeStateResult[] $envelopeStateResult
     * @return \ArrayType\ArrayOfEnvelopeStateResult
     */
    public function setEnvelopeStateResult(array $envelopeStateResult = array())
    {
        // validation for constraint: array
        if ('' !== ($envelopeStateResultArrayErrorMessage = self::validateEnvelopeStateResultForArrayConstraintsFromSetEnvelopeStateResult($envelopeStateResult))) {
            throw new \InvalidArgumentException($envelopeStateResultArrayErrorMessage, __LINE__);
        }
        if (is_null($envelopeStateResult) || (is_array($envelopeStateResult) && empty($envelopeStateResult))) {
            unset($this->EnvelopeStateResult);
        } else {
            $this->EnvelopeStateResult = $envelopeStateResult;
        }
        return $this;
    }
    /**
     * Add item to EnvelopeStateResult value
     * @throws \InvalidArgumentException
     * @param \StructType\EnvelopeStateResult $item
     * @return \ArrayType\ArrayOfEnvelopeStateResult
     */
    public function addToEnvelopeStateResult(\StructType\EnvelopeStateResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EnvelopeStateResult) {
            throw new \InvalidArgumentException(sprintf('The EnvelopeStateResult property can only contain items of type \StructType\EnvelopeStateResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EnvelopeStateResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EnvelopeStateResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EnvelopeStateResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EnvelopeStateResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EnvelopeStateResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EnvelopeStateResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EnvelopeStateResult
     */
    public function getAttributeName()
    {
        return 'EnvelopeStateResult';
    }
}
