<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIncomingDespatchAdviceCount ArrayType
 * @subpackage Arrays
 */
class ArrayOfIncomingDespatchAdviceCount extends AbstractStructArrayBase
{
    /**
     * The IncomingDespatchAdviceCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IncomingDespatchAdviceCount[]
     */
    public $IncomingDespatchAdviceCount;
    /**
     * Constructor method for ArrayOfIncomingDespatchAdviceCount
     * @uses ArrayOfIncomingDespatchAdviceCount::setIncomingDespatchAdviceCount()
     * @param \StructType\IncomingDespatchAdviceCount[] $incomingDespatchAdviceCount
     */
    public function __construct(array $incomingDespatchAdviceCount = array())
    {
        $this
            ->setIncomingDespatchAdviceCount($incomingDespatchAdviceCount);
    }
    /**
     * Get IncomingDespatchAdviceCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IncomingDespatchAdviceCount[]|null
     */
    public function getIncomingDespatchAdviceCount()
    {
        return isset($this->IncomingDespatchAdviceCount) ? $this->IncomingDespatchAdviceCount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIncomingDespatchAdviceCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIncomingDespatchAdviceCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIncomingDespatchAdviceCountForArrayConstraintsFromSetIncomingDespatchAdviceCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIncomingDespatchAdviceCountIncomingDespatchAdviceCountItem) {
            // validation for constraint: itemType
            if (!$arrayOfIncomingDespatchAdviceCountIncomingDespatchAdviceCountItem instanceof \StructType\IncomingDespatchAdviceCount) {
                $invalidValues[] = is_object($arrayOfIncomingDespatchAdviceCountIncomingDespatchAdviceCountItem) ? get_class($arrayOfIncomingDespatchAdviceCountIncomingDespatchAdviceCountItem) : sprintf('%s(%s)', gettype($arrayOfIncomingDespatchAdviceCountIncomingDespatchAdviceCountItem), var_export($arrayOfIncomingDespatchAdviceCountIncomingDespatchAdviceCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IncomingDespatchAdviceCount property can only contain items of type \StructType\IncomingDespatchAdviceCount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IncomingDespatchAdviceCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IncomingDespatchAdviceCount[] $incomingDespatchAdviceCount
     * @return \ArrayType\ArrayOfIncomingDespatchAdviceCount
     */
    public function setIncomingDespatchAdviceCount(array $incomingDespatchAdviceCount = array())
    {
        // validation for constraint: array
        if ('' !== ($incomingDespatchAdviceCountArrayErrorMessage = self::validateIncomingDespatchAdviceCountForArrayConstraintsFromSetIncomingDespatchAdviceCount($incomingDespatchAdviceCount))) {
            throw new \InvalidArgumentException($incomingDespatchAdviceCountArrayErrorMessage, __LINE__);
        }
        if (is_null($incomingDespatchAdviceCount) || (is_array($incomingDespatchAdviceCount) && empty($incomingDespatchAdviceCount))) {
            unset($this->IncomingDespatchAdviceCount);
        } else {
            $this->IncomingDespatchAdviceCount = $incomingDespatchAdviceCount;
        }
        return $this;
    }
    /**
     * Add item to IncomingDespatchAdviceCount value
     * @throws \InvalidArgumentException
     * @param \StructType\IncomingDespatchAdviceCount $item
     * @return \ArrayType\ArrayOfIncomingDespatchAdviceCount
     */
    public function addToIncomingDespatchAdviceCount(\StructType\IncomingDespatchAdviceCount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IncomingDespatchAdviceCount) {
            throw new \InvalidArgumentException(sprintf('The IncomingDespatchAdviceCount property can only contain items of type \StructType\IncomingDespatchAdviceCount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IncomingDespatchAdviceCount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IncomingDespatchAdviceCount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IncomingDespatchAdviceCount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IncomingDespatchAdviceCount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IncomingDespatchAdviceCount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IncomingDespatchAdviceCount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IncomingDespatchAdviceCount
     */
    public function getAttributeName()
    {
        return 'IncomingDespatchAdviceCount';
    }
}
