<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIncomingInvoiceCount ArrayType
 * @subpackage Arrays
 */
class ArrayOfIncomingInvoiceCount extends AbstractStructArrayBase
{
    /**
     * The IncomingInvoiceCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IncomingInvoiceCount[]
     */
    public $IncomingInvoiceCount;
    /**
     * Constructor method for ArrayOfIncomingInvoiceCount
     * @uses ArrayOfIncomingInvoiceCount::setIncomingInvoiceCount()
     * @param \StructType\IncomingInvoiceCount[] $incomingInvoiceCount
     */
    public function __construct(array $incomingInvoiceCount = array())
    {
        $this
            ->setIncomingInvoiceCount($incomingInvoiceCount);
    }
    /**
     * Get IncomingInvoiceCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IncomingInvoiceCount[]|null
     */
    public function getIncomingInvoiceCount()
    {
        return isset($this->IncomingInvoiceCount) ? $this->IncomingInvoiceCount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIncomingInvoiceCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIncomingInvoiceCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIncomingInvoiceCountForArrayConstraintsFromSetIncomingInvoiceCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIncomingInvoiceCountIncomingInvoiceCountItem) {
            // validation for constraint: itemType
            if (!$arrayOfIncomingInvoiceCountIncomingInvoiceCountItem instanceof \StructType\IncomingInvoiceCount) {
                $invalidValues[] = is_object($arrayOfIncomingInvoiceCountIncomingInvoiceCountItem) ? get_class($arrayOfIncomingInvoiceCountIncomingInvoiceCountItem) : sprintf('%s(%s)', gettype($arrayOfIncomingInvoiceCountIncomingInvoiceCountItem), var_export($arrayOfIncomingInvoiceCountIncomingInvoiceCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IncomingInvoiceCount property can only contain items of type \StructType\IncomingInvoiceCount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IncomingInvoiceCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IncomingInvoiceCount[] $incomingInvoiceCount
     * @return \ArrayType\ArrayOfIncomingInvoiceCount
     */
    public function setIncomingInvoiceCount(array $incomingInvoiceCount = array())
    {
        // validation for constraint: array
        if ('' !== ($incomingInvoiceCountArrayErrorMessage = self::validateIncomingInvoiceCountForArrayConstraintsFromSetIncomingInvoiceCount($incomingInvoiceCount))) {
            throw new \InvalidArgumentException($incomingInvoiceCountArrayErrorMessage, __LINE__);
        }
        if (is_null($incomingInvoiceCount) || (is_array($incomingInvoiceCount) && empty($incomingInvoiceCount))) {
            unset($this->IncomingInvoiceCount);
        } else {
            $this->IncomingInvoiceCount = $incomingInvoiceCount;
        }
        return $this;
    }
    /**
     * Add item to IncomingInvoiceCount value
     * @throws \InvalidArgumentException
     * @param \StructType\IncomingInvoiceCount $item
     * @return \ArrayType\ArrayOfIncomingInvoiceCount
     */
    public function addToIncomingInvoiceCount(\StructType\IncomingInvoiceCount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IncomingInvoiceCount) {
            throw new \InvalidArgumentException(sprintf('The IncomingInvoiceCount property can only contain items of type \StructType\IncomingInvoiceCount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IncomingInvoiceCount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IncomingInvoiceCount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IncomingInvoiceCount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IncomingInvoiceCount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IncomingInvoiceCount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IncomingInvoiceCount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IncomingInvoiceCount
     */
    public function getAttributeName()
    {
        return 'IncomingInvoiceCount';
    }
}
