<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvoiceCountWithDate ArrayType
 * @subpackage Arrays
 */
class ArrayOfInvoiceCountWithDate extends AbstractStructArrayBase
{
    /**
     * The InvoiceCountWithDate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceCountWithDate[]
     */
    public $InvoiceCountWithDate;
    /**
     * Constructor method for ArrayOfInvoiceCountWithDate
     * @uses ArrayOfInvoiceCountWithDate::setInvoiceCountWithDate()
     * @param \StructType\InvoiceCountWithDate[] $invoiceCountWithDate
     */
    public function __construct(array $invoiceCountWithDate = array())
    {
        $this
            ->setInvoiceCountWithDate($invoiceCountWithDate);
    }
    /**
     * Get InvoiceCountWithDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceCountWithDate[]|null
     */
    public function getInvoiceCountWithDate()
    {
        return isset($this->InvoiceCountWithDate) ? $this->InvoiceCountWithDate : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoiceCountWithDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoiceCountWithDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoiceCountWithDateForArrayConstraintsFromSetInvoiceCountWithDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvoiceCountWithDateInvoiceCountWithDateItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvoiceCountWithDateInvoiceCountWithDateItem instanceof \StructType\InvoiceCountWithDate) {
                $invalidValues[] = is_object($arrayOfInvoiceCountWithDateInvoiceCountWithDateItem) ? get_class($arrayOfInvoiceCountWithDateInvoiceCountWithDateItem) : sprintf('%s(%s)', gettype($arrayOfInvoiceCountWithDateInvoiceCountWithDateItem), var_export($arrayOfInvoiceCountWithDateInvoiceCountWithDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoiceCountWithDate property can only contain items of type \StructType\InvoiceCountWithDate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoiceCountWithDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceCountWithDate[] $invoiceCountWithDate
     * @return \ArrayType\ArrayOfInvoiceCountWithDate
     */
    public function setInvoiceCountWithDate(array $invoiceCountWithDate = array())
    {
        // validation for constraint: array
        if ('' !== ($invoiceCountWithDateArrayErrorMessage = self::validateInvoiceCountWithDateForArrayConstraintsFromSetInvoiceCountWithDate($invoiceCountWithDate))) {
            throw new \InvalidArgumentException($invoiceCountWithDateArrayErrorMessage, __LINE__);
        }
        if (is_null($invoiceCountWithDate) || (is_array($invoiceCountWithDate) && empty($invoiceCountWithDate))) {
            unset($this->InvoiceCountWithDate);
        } else {
            $this->InvoiceCountWithDate = $invoiceCountWithDate;
        }
        return $this;
    }
    /**
     * Add item to InvoiceCountWithDate value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceCountWithDate $item
     * @return \ArrayType\ArrayOfInvoiceCountWithDate
     */
    public function addToInvoiceCountWithDate(\StructType\InvoiceCountWithDate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceCountWithDate) {
            throw new \InvalidArgumentException(sprintf('The InvoiceCountWithDate property can only contain items of type \StructType\InvoiceCountWithDate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoiceCountWithDate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InvoiceCountWithDate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InvoiceCountWithDate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InvoiceCountWithDate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InvoiceCountWithDate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InvoiceCountWithDate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvoiceCountWithDate
     */
    public function getAttributeName()
    {
        return 'InvoiceCountWithDate';
    }
}
