<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvoiceIDRecordResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfInvoiceIDRecordResult extends AbstractStructArrayBase
{
    /**
     * The InvoiceIDRecordResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceIDRecordResult[]
     */
    public $InvoiceIDRecordResult;
    /**
     * Constructor method for ArrayOfInvoiceIDRecordResult
     * @uses ArrayOfInvoiceIDRecordResult::setInvoiceIDRecordResult()
     * @param \StructType\InvoiceIDRecordResult[] $invoiceIDRecordResult
     */
    public function __construct(array $invoiceIDRecordResult = array())
    {
        $this
            ->setInvoiceIDRecordResult($invoiceIDRecordResult);
    }
    /**
     * Get InvoiceIDRecordResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceIDRecordResult[]|null
     */
    public function getInvoiceIDRecordResult()
    {
        return isset($this->InvoiceIDRecordResult) ? $this->InvoiceIDRecordResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoiceIDRecordResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoiceIDRecordResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoiceIDRecordResultForArrayConstraintsFromSetInvoiceIDRecordResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvoiceIDRecordResultInvoiceIDRecordResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvoiceIDRecordResultInvoiceIDRecordResultItem instanceof \StructType\InvoiceIDRecordResult) {
                $invalidValues[] = is_object($arrayOfInvoiceIDRecordResultInvoiceIDRecordResultItem) ? get_class($arrayOfInvoiceIDRecordResultInvoiceIDRecordResultItem) : sprintf('%s(%s)', gettype($arrayOfInvoiceIDRecordResultInvoiceIDRecordResultItem), var_export($arrayOfInvoiceIDRecordResultInvoiceIDRecordResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoiceIDRecordResult property can only contain items of type \StructType\InvoiceIDRecordResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoiceIDRecordResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceIDRecordResult[] $invoiceIDRecordResult
     * @return \ArrayType\ArrayOfInvoiceIDRecordResult
     */
    public function setInvoiceIDRecordResult(array $invoiceIDRecordResult = array())
    {
        // validation for constraint: array
        if ('' !== ($invoiceIDRecordResultArrayErrorMessage = self::validateInvoiceIDRecordResultForArrayConstraintsFromSetInvoiceIDRecordResult($invoiceIDRecordResult))) {
            throw new \InvalidArgumentException($invoiceIDRecordResultArrayErrorMessage, __LINE__);
        }
        if (is_null($invoiceIDRecordResult) || (is_array($invoiceIDRecordResult) && empty($invoiceIDRecordResult))) {
            unset($this->InvoiceIDRecordResult);
        } else {
            $this->InvoiceIDRecordResult = $invoiceIDRecordResult;
        }
        return $this;
    }
    /**
     * Add item to InvoiceIDRecordResult value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceIDRecordResult $item
     * @return \ArrayType\ArrayOfInvoiceIDRecordResult
     */
    public function addToInvoiceIDRecordResult(\StructType\InvoiceIDRecordResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceIDRecordResult) {
            throw new \InvalidArgumentException(sprintf('The InvoiceIDRecordResult property can only contain items of type \StructType\InvoiceIDRecordResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoiceIDRecordResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InvoiceIDRecordResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InvoiceIDRecordResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InvoiceIDRecordResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InvoiceIDRecordResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InvoiceIDRecordResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvoiceIDRecordResult
     */
    public function getAttributeName()
    {
        return 'InvoiceIDRecordResult';
    }
}
