<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvoiceInfoResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfInvoiceInfoResult extends AbstractStructArrayBase
{
    /**
     * The InvoiceInfoResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceInfoResult[]
     */
    public $InvoiceInfoResult;
    /**
     * Constructor method for ArrayOfInvoiceInfoResult
     * @uses ArrayOfInvoiceInfoResult::setInvoiceInfoResult()
     * @param \StructType\InvoiceInfoResult[] $invoiceInfoResult
     */
    public function __construct(array $invoiceInfoResult = array())
    {
        $this
            ->setInvoiceInfoResult($invoiceInfoResult);
    }
    /**
     * Get InvoiceInfoResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceInfoResult[]|null
     */
    public function getInvoiceInfoResult()
    {
        return isset($this->InvoiceInfoResult) ? $this->InvoiceInfoResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoiceInfoResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoiceInfoResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoiceInfoResultForArrayConstraintsFromSetInvoiceInfoResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvoiceInfoResultInvoiceInfoResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvoiceInfoResultInvoiceInfoResultItem instanceof \StructType\InvoiceInfoResult) {
                $invalidValues[] = is_object($arrayOfInvoiceInfoResultInvoiceInfoResultItem) ? get_class($arrayOfInvoiceInfoResultInvoiceInfoResultItem) : sprintf('%s(%s)', gettype($arrayOfInvoiceInfoResultInvoiceInfoResultItem), var_export($arrayOfInvoiceInfoResultInvoiceInfoResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoiceInfoResult property can only contain items of type \StructType\InvoiceInfoResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoiceInfoResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceInfoResult[] $invoiceInfoResult
     * @return \ArrayType\ArrayOfInvoiceInfoResult
     */
    public function setInvoiceInfoResult(array $invoiceInfoResult = array())
    {
        // validation for constraint: array
        if ('' !== ($invoiceInfoResultArrayErrorMessage = self::validateInvoiceInfoResultForArrayConstraintsFromSetInvoiceInfoResult($invoiceInfoResult))) {
            throw new \InvalidArgumentException($invoiceInfoResultArrayErrorMessage, __LINE__);
        }
        if (is_null($invoiceInfoResult) || (is_array($invoiceInfoResult) && empty($invoiceInfoResult))) {
            unset($this->InvoiceInfoResult);
        } else {
            $this->InvoiceInfoResult = $invoiceInfoResult;
        }
        return $this;
    }
    /**
     * Add item to InvoiceInfoResult value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceInfoResult $item
     * @return \ArrayType\ArrayOfInvoiceInfoResult
     */
    public function addToInvoiceInfoResult(\StructType\InvoiceInfoResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceInfoResult) {
            throw new \InvalidArgumentException(sprintf('The InvoiceInfoResult property can only contain items of type \StructType\InvoiceInfoResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoiceInfoResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InvoiceInfoResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InvoiceInfoResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InvoiceInfoResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InvoiceInfoResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InvoiceInfoResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvoiceInfoResult
     */
    public function getAttributeName()
    {
        return 'InvoiceInfoResult';
    }
}
