<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOutSiderMailMessageAttach ArrayType
 * @subpackage Arrays
 */
class ArrayOfOutSiderMailMessageAttach extends AbstractStructArrayBase
{
    /**
     * The OutSiderMailMessageAttach
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutSiderMailMessageAttach[]
     */
    public $OutSiderMailMessageAttach;
    /**
     * Constructor method for ArrayOfOutSiderMailMessageAttach
     * @uses ArrayOfOutSiderMailMessageAttach::setOutSiderMailMessageAttach()
     * @param \StructType\OutSiderMailMessageAttach[] $outSiderMailMessageAttach
     */
    public function __construct(array $outSiderMailMessageAttach = array())
    {
        $this
            ->setOutSiderMailMessageAttach($outSiderMailMessageAttach);
    }
    /**
     * Get OutSiderMailMessageAttach value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutSiderMailMessageAttach[]|null
     */
    public function getOutSiderMailMessageAttach()
    {
        return isset($this->OutSiderMailMessageAttach) ? $this->OutSiderMailMessageAttach : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOutSiderMailMessageAttach method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOutSiderMailMessageAttach method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOutSiderMailMessageAttachForArrayConstraintsFromSetOutSiderMailMessageAttach(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOutSiderMailMessageAttachOutSiderMailMessageAttachItem) {
            // validation for constraint: itemType
            if (!$arrayOfOutSiderMailMessageAttachOutSiderMailMessageAttachItem instanceof \StructType\OutSiderMailMessageAttach) {
                $invalidValues[] = is_object($arrayOfOutSiderMailMessageAttachOutSiderMailMessageAttachItem) ? get_class($arrayOfOutSiderMailMessageAttachOutSiderMailMessageAttachItem) : sprintf('%s(%s)', gettype($arrayOfOutSiderMailMessageAttachOutSiderMailMessageAttachItem), var_export($arrayOfOutSiderMailMessageAttachOutSiderMailMessageAttachItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OutSiderMailMessageAttach property can only contain items of type \StructType\OutSiderMailMessageAttach, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OutSiderMailMessageAttach value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutSiderMailMessageAttach[] $outSiderMailMessageAttach
     * @return \ArrayType\ArrayOfOutSiderMailMessageAttach
     */
    public function setOutSiderMailMessageAttach(array $outSiderMailMessageAttach = array())
    {
        // validation for constraint: array
        if ('' !== ($outSiderMailMessageAttachArrayErrorMessage = self::validateOutSiderMailMessageAttachForArrayConstraintsFromSetOutSiderMailMessageAttach($outSiderMailMessageAttach))) {
            throw new \InvalidArgumentException($outSiderMailMessageAttachArrayErrorMessage, __LINE__);
        }
        if (is_null($outSiderMailMessageAttach) || (is_array($outSiderMailMessageAttach) && empty($outSiderMailMessageAttach))) {
            unset($this->OutSiderMailMessageAttach);
        } else {
            $this->OutSiderMailMessageAttach = $outSiderMailMessageAttach;
        }
        return $this;
    }
    /**
     * Add item to OutSiderMailMessageAttach value
     * @throws \InvalidArgumentException
     * @param \StructType\OutSiderMailMessageAttach $item
     * @return \ArrayType\ArrayOfOutSiderMailMessageAttach
     */
    public function addToOutSiderMailMessageAttach(\StructType\OutSiderMailMessageAttach $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutSiderMailMessageAttach) {
            throw new \InvalidArgumentException(sprintf('The OutSiderMailMessageAttach property can only contain items of type \StructType\OutSiderMailMessageAttach, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OutSiderMailMessageAttach[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OutSiderMailMessageAttach|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OutSiderMailMessageAttach|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OutSiderMailMessageAttach|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OutSiderMailMessageAttach|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OutSiderMailMessageAttach|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OutSiderMailMessageAttach
     */
    public function getAttributeName()
    {
        return 'OutSiderMailMessageAttach';
    }
}
