<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOutgoingDespatchAdviceCount ArrayType
 * @subpackage Arrays
 */
class ArrayOfOutgoingDespatchAdviceCount extends AbstractStructArrayBase
{
    /**
     * The OutgoingDespatchAdviceCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutgoingDespatchAdviceCount[]
     */
    public $OutgoingDespatchAdviceCount;
    /**
     * Constructor method for ArrayOfOutgoingDespatchAdviceCount
     * @uses ArrayOfOutgoingDespatchAdviceCount::setOutgoingDespatchAdviceCount()
     * @param \StructType\OutgoingDespatchAdviceCount[] $outgoingDespatchAdviceCount
     */
    public function __construct(array $outgoingDespatchAdviceCount = array())
    {
        $this
            ->setOutgoingDespatchAdviceCount($outgoingDespatchAdviceCount);
    }
    /**
     * Get OutgoingDespatchAdviceCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutgoingDespatchAdviceCount[]|null
     */
    public function getOutgoingDespatchAdviceCount()
    {
        return isset($this->OutgoingDespatchAdviceCount) ? $this->OutgoingDespatchAdviceCount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOutgoingDespatchAdviceCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOutgoingDespatchAdviceCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOutgoingDespatchAdviceCountForArrayConstraintsFromSetOutgoingDespatchAdviceCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOutgoingDespatchAdviceCountOutgoingDespatchAdviceCountItem) {
            // validation for constraint: itemType
            if (!$arrayOfOutgoingDespatchAdviceCountOutgoingDespatchAdviceCountItem instanceof \StructType\OutgoingDespatchAdviceCount) {
                $invalidValues[] = is_object($arrayOfOutgoingDespatchAdviceCountOutgoingDespatchAdviceCountItem) ? get_class($arrayOfOutgoingDespatchAdviceCountOutgoingDespatchAdviceCountItem) : sprintf('%s(%s)', gettype($arrayOfOutgoingDespatchAdviceCountOutgoingDespatchAdviceCountItem), var_export($arrayOfOutgoingDespatchAdviceCountOutgoingDespatchAdviceCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OutgoingDespatchAdviceCount property can only contain items of type \StructType\OutgoingDespatchAdviceCount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OutgoingDespatchAdviceCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutgoingDespatchAdviceCount[] $outgoingDespatchAdviceCount
     * @return \ArrayType\ArrayOfOutgoingDespatchAdviceCount
     */
    public function setOutgoingDespatchAdviceCount(array $outgoingDespatchAdviceCount = array())
    {
        // validation for constraint: array
        if ('' !== ($outgoingDespatchAdviceCountArrayErrorMessage = self::validateOutgoingDespatchAdviceCountForArrayConstraintsFromSetOutgoingDespatchAdviceCount($outgoingDespatchAdviceCount))) {
            throw new \InvalidArgumentException($outgoingDespatchAdviceCountArrayErrorMessage, __LINE__);
        }
        if (is_null($outgoingDespatchAdviceCount) || (is_array($outgoingDespatchAdviceCount) && empty($outgoingDespatchAdviceCount))) {
            unset($this->OutgoingDespatchAdviceCount);
        } else {
            $this->OutgoingDespatchAdviceCount = $outgoingDespatchAdviceCount;
        }
        return $this;
    }
    /**
     * Add item to OutgoingDespatchAdviceCount value
     * @throws \InvalidArgumentException
     * @param \StructType\OutgoingDespatchAdviceCount $item
     * @return \ArrayType\ArrayOfOutgoingDespatchAdviceCount
     */
    public function addToOutgoingDespatchAdviceCount(\StructType\OutgoingDespatchAdviceCount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutgoingDespatchAdviceCount) {
            throw new \InvalidArgumentException(sprintf('The OutgoingDespatchAdviceCount property can only contain items of type \StructType\OutgoingDespatchAdviceCount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OutgoingDespatchAdviceCount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OutgoingDespatchAdviceCount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OutgoingDespatchAdviceCount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OutgoingDespatchAdviceCount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OutgoingDespatchAdviceCount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OutgoingDespatchAdviceCount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OutgoingDespatchAdviceCount
     */
    public function getAttributeName()
    {
        return 'OutgoingDespatchAdviceCount';
    }
}
