<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOutgoingInvoiceCount ArrayType
 * @subpackage Arrays
 */
class ArrayOfOutgoingInvoiceCount extends AbstractStructArrayBase
{
    /**
     * The OutgoingInvoiceCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutgoingInvoiceCount[]
     */
    public $OutgoingInvoiceCount;
    /**
     * Constructor method for ArrayOfOutgoingInvoiceCount
     * @uses ArrayOfOutgoingInvoiceCount::setOutgoingInvoiceCount()
     * @param \StructType\OutgoingInvoiceCount[] $outgoingInvoiceCount
     */
    public function __construct(array $outgoingInvoiceCount = array())
    {
        $this
            ->setOutgoingInvoiceCount($outgoingInvoiceCount);
    }
    /**
     * Get OutgoingInvoiceCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutgoingInvoiceCount[]|null
     */
    public function getOutgoingInvoiceCount()
    {
        return isset($this->OutgoingInvoiceCount) ? $this->OutgoingInvoiceCount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOutgoingInvoiceCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOutgoingInvoiceCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOutgoingInvoiceCountForArrayConstraintsFromSetOutgoingInvoiceCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOutgoingInvoiceCountOutgoingInvoiceCountItem) {
            // validation for constraint: itemType
            if (!$arrayOfOutgoingInvoiceCountOutgoingInvoiceCountItem instanceof \StructType\OutgoingInvoiceCount) {
                $invalidValues[] = is_object($arrayOfOutgoingInvoiceCountOutgoingInvoiceCountItem) ? get_class($arrayOfOutgoingInvoiceCountOutgoingInvoiceCountItem) : sprintf('%s(%s)', gettype($arrayOfOutgoingInvoiceCountOutgoingInvoiceCountItem), var_export($arrayOfOutgoingInvoiceCountOutgoingInvoiceCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OutgoingInvoiceCount property can only contain items of type \StructType\OutgoingInvoiceCount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OutgoingInvoiceCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutgoingInvoiceCount[] $outgoingInvoiceCount
     * @return \ArrayType\ArrayOfOutgoingInvoiceCount
     */
    public function setOutgoingInvoiceCount(array $outgoingInvoiceCount = array())
    {
        // validation for constraint: array
        if ('' !== ($outgoingInvoiceCountArrayErrorMessage = self::validateOutgoingInvoiceCountForArrayConstraintsFromSetOutgoingInvoiceCount($outgoingInvoiceCount))) {
            throw new \InvalidArgumentException($outgoingInvoiceCountArrayErrorMessage, __LINE__);
        }
        if (is_null($outgoingInvoiceCount) || (is_array($outgoingInvoiceCount) && empty($outgoingInvoiceCount))) {
            unset($this->OutgoingInvoiceCount);
        } else {
            $this->OutgoingInvoiceCount = $outgoingInvoiceCount;
        }
        return $this;
    }
    /**
     * Add item to OutgoingInvoiceCount value
     * @throws \InvalidArgumentException
     * @param \StructType\OutgoingInvoiceCount $item
     * @return \ArrayType\ArrayOfOutgoingInvoiceCount
     */
    public function addToOutgoingInvoiceCount(\StructType\OutgoingInvoiceCount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutgoingInvoiceCount) {
            throw new \InvalidArgumentException(sprintf('The OutgoingInvoiceCount property can only contain items of type \StructType\OutgoingInvoiceCount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OutgoingInvoiceCount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OutgoingInvoiceCount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OutgoingInvoiceCount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OutgoingInvoiceCount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OutgoingInvoiceCount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OutgoingInvoiceCount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OutgoingInvoiceCount
     */
    public function getAttributeName()
    {
        return 'OutgoingInvoiceCount';
    }
}
