<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProducersReceiptCount ArrayType
 * @subpackage Arrays
 */
class ArrayOfProducersReceiptCount extends AbstractStructArrayBase
{
    /**
     * The ProducersReceiptCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProducersReceiptCount[]
     */
    public $ProducersReceiptCount;
    /**
     * Constructor method for ArrayOfProducersReceiptCount
     * @uses ArrayOfProducersReceiptCount::setProducersReceiptCount()
     * @param \StructType\ProducersReceiptCount[] $producersReceiptCount
     */
    public function __construct(array $producersReceiptCount = array())
    {
        $this
            ->setProducersReceiptCount($producersReceiptCount);
    }
    /**
     * Get ProducersReceiptCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProducersReceiptCount[]|null
     */
    public function getProducersReceiptCount()
    {
        return isset($this->ProducersReceiptCount) ? $this->ProducersReceiptCount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProducersReceiptCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProducersReceiptCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProducersReceiptCountForArrayConstraintsFromSetProducersReceiptCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProducersReceiptCountProducersReceiptCountItem) {
            // validation for constraint: itemType
            if (!$arrayOfProducersReceiptCountProducersReceiptCountItem instanceof \StructType\ProducersReceiptCount) {
                $invalidValues[] = is_object($arrayOfProducersReceiptCountProducersReceiptCountItem) ? get_class($arrayOfProducersReceiptCountProducersReceiptCountItem) : sprintf('%s(%s)', gettype($arrayOfProducersReceiptCountProducersReceiptCountItem), var_export($arrayOfProducersReceiptCountProducersReceiptCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProducersReceiptCount property can only contain items of type \StructType\ProducersReceiptCount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProducersReceiptCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProducersReceiptCount[] $producersReceiptCount
     * @return \ArrayType\ArrayOfProducersReceiptCount
     */
    public function setProducersReceiptCount(array $producersReceiptCount = array())
    {
        // validation for constraint: array
        if ('' !== ($producersReceiptCountArrayErrorMessage = self::validateProducersReceiptCountForArrayConstraintsFromSetProducersReceiptCount($producersReceiptCount))) {
            throw new \InvalidArgumentException($producersReceiptCountArrayErrorMessage, __LINE__);
        }
        if (is_null($producersReceiptCount) || (is_array($producersReceiptCount) && empty($producersReceiptCount))) {
            unset($this->ProducersReceiptCount);
        } else {
            $this->ProducersReceiptCount = $producersReceiptCount;
        }
        return $this;
    }
    /**
     * Add item to ProducersReceiptCount value
     * @throws \InvalidArgumentException
     * @param \StructType\ProducersReceiptCount $item
     * @return \ArrayType\ArrayOfProducersReceiptCount
     */
    public function addToProducersReceiptCount(\StructType\ProducersReceiptCount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProducersReceiptCount) {
            throw new \InvalidArgumentException(sprintf('The ProducersReceiptCount property can only contain items of type \StructType\ProducersReceiptCount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProducersReceiptCount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProducersReceiptCount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProducersReceiptCount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProducersReceiptCount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProducersReceiptCount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProducersReceiptCount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProducersReceiptCount
     */
    public function getAttributeName()
    {
        return 'ProducersReceiptCount';
    }
}
