<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProducersSevoucherCount ArrayType
 * @subpackage Arrays
 */
class ArrayOfProducersSevoucherCount extends AbstractStructArrayBase
{
    /**
     * The ProducersSevoucherCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProducersSevoucherCount[]
     */
    public $ProducersSevoucherCount;
    /**
     * Constructor method for ArrayOfProducersSevoucherCount
     * @uses ArrayOfProducersSevoucherCount::setProducersSevoucherCount()
     * @param \StructType\ProducersSevoucherCount[] $producersSevoucherCount
     */
    public function __construct(array $producersSevoucherCount = array())
    {
        $this
            ->setProducersSevoucherCount($producersSevoucherCount);
    }
    /**
     * Get ProducersSevoucherCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProducersSevoucherCount[]|null
     */
    public function getProducersSevoucherCount()
    {
        return isset($this->ProducersSevoucherCount) ? $this->ProducersSevoucherCount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProducersSevoucherCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProducersSevoucherCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProducersSevoucherCountForArrayConstraintsFromSetProducersSevoucherCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProducersSevoucherCountProducersSevoucherCountItem) {
            // validation for constraint: itemType
            if (!$arrayOfProducersSevoucherCountProducersSevoucherCountItem instanceof \StructType\ProducersSevoucherCount) {
                $invalidValues[] = is_object($arrayOfProducersSevoucherCountProducersSevoucherCountItem) ? get_class($arrayOfProducersSevoucherCountProducersSevoucherCountItem) : sprintf('%s(%s)', gettype($arrayOfProducersSevoucherCountProducersSevoucherCountItem), var_export($arrayOfProducersSevoucherCountProducersSevoucherCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProducersSevoucherCount property can only contain items of type \StructType\ProducersSevoucherCount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProducersSevoucherCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProducersSevoucherCount[] $producersSevoucherCount
     * @return \ArrayType\ArrayOfProducersSevoucherCount
     */
    public function setProducersSevoucherCount(array $producersSevoucherCount = array())
    {
        // validation for constraint: array
        if ('' !== ($producersSevoucherCountArrayErrorMessage = self::validateProducersSevoucherCountForArrayConstraintsFromSetProducersSevoucherCount($producersSevoucherCount))) {
            throw new \InvalidArgumentException($producersSevoucherCountArrayErrorMessage, __LINE__);
        }
        if (is_null($producersSevoucherCount) || (is_array($producersSevoucherCount) && empty($producersSevoucherCount))) {
            unset($this->ProducersSevoucherCount);
        } else {
            $this->ProducersSevoucherCount = $producersSevoucherCount;
        }
        return $this;
    }
    /**
     * Add item to ProducersSevoucherCount value
     * @throws \InvalidArgumentException
     * @param \StructType\ProducersSevoucherCount $item
     * @return \ArrayType\ArrayOfProducersSevoucherCount
     */
    public function addToProducersSevoucherCount(\StructType\ProducersSevoucherCount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProducersSevoucherCount) {
            throw new \InvalidArgumentException(sprintf('The ProducersSevoucherCount property can only contain items of type \StructType\ProducersSevoucherCount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProducersSevoucherCount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProducersSevoucherCount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProducersSevoucherCount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProducersSevoucherCount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProducersSevoucherCount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProducersSevoucherCount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProducersSevoucherCount
     */
    public function getAttributeName()
    {
        return 'ProducersSevoucherCount';
    }
}
