<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetAvailableApplicationResponses' => '\\StructType\\GetAvailableApplicationResponses',
            'GetAvailableApplicationResponsesResponse' => '\\StructType\\GetAvailableApplicationResponsesResponse',
            'ApplicationResponsePackResult' => '\\StructType\\ApplicationResponsePackResult',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'SendApplicationResponse' => '\\StructType\\SendApplicationResponse',
            'SendApplicationResponseResponse' => '\\StructType\\SendApplicationResponseResponse',
            'ApplicationResponseResult' => '\\StructType\\ApplicationResponseResult',
            'SendMailQueueAgainResponse' => '\\StructType\\SendMailQueueAgainResponse',
            'SendMailQueueAgainResponseResponse' => '\\StructType\\SendMailQueueAgainResponseResponse',
            'SendInvoiceData' => '\\StructType\\SendInvoiceData',
            'SendInvoiceDataResponse' => '\\StructType\\SendInvoiceDataResponse',
            'EnvelopeStateResult' => '\\StructType\\EnvelopeStateResult',
            'ArrayOfInvoiceStateResult' => '\\ArrayType\\ArrayOfInvoiceStateResult',
            'InvoiceStateResult' => '\\StructType\\InvoiceStateResult',
            'SendEArchiveData' => '\\StructType\\SendEArchiveData',
            'SendEArchiveDataResponse' => '\\StructType\\SendEArchiveDataResponse',
            'EArchiveStateResult' => '\\StructType\\EArchiveStateResult',
            'SendBase64StringEArchiveData' => '\\StructType\\SendBase64StringEArchiveData',
            'SendBase64StringEArchiveDataResponse' => '\\StructType\\SendBase64StringEArchiveDataResponse',
            'ReSendInvoiceData' => '\\StructType\\ReSendInvoiceData',
            'ReSendInvoiceDataResponse' => '\\StructType\\ReSendInvoiceDataResponse',
            'SendInvoiceDataWithTemplateCode' => '\\StructType\\SendInvoiceDataWithTemplateCode',
            'SendInvoiceDataWithTemplateCodeResponse' => '\\StructType\\SendInvoiceDataWithTemplateCodeResponse',
            'SendEArchiveDataWithTemplateCode' => '\\StructType\\SendEArchiveDataWithTemplateCode',
            'SendEArchiveDataWithTemplateCodeResponse' => '\\StructType\\SendEArchiveDataWithTemplateCodeResponse',
            'SendBase64StringEArchiveDataWithTemplateCode' => '\\StructType\\SendBase64StringEArchiveDataWithTemplateCode',
            'SendBase64StringEArchiveDataWithTemplateCodeResponse' => '\\StructType\\SendBase64StringEArchiveDataWithTemplateCodeResponse',
            'CancelEArchiveInvoice' => '\\StructType\\CancelEArchiveInvoice',
            'CancelEArchiveInvoiceResponse' => '\\StructType\\CancelEArchiveInvoiceResponse',
            'InvoiceInfoResult' => '\\StructType\\InvoiceInfoResult',
            'ArrayOfInvoiceOption' => '\\ArrayType\\ArrayOfInvoiceOption',
            'InvoiceOption' => '\\StructType\\InvoiceOption',
            'CancelInvoiceNumber' => '\\StructType\\CancelInvoiceNumber',
            'CancelInvoiceNumberResponse' => '\\StructType\\CancelInvoiceNumberResponse',
            'CancelInvoiceNumberResult' => '\\StructType\\CancelInvoiceNumberResult',
            'CancelEArchiveInvoiceStringDate' => '\\StructType\\CancelEArchiveInvoiceStringDate',
            'CancelEArchiveInvoiceStringDateResponse' => '\\StructType\\CancelEArchiveInvoiceStringDateResponse',
            'CancelEArchiveInvoiceStringDateAndAmount' => '\\StructType\\CancelEArchiveInvoiceStringDateAndAmount',
            'CancelEArchiveInvoiceStringDateAndAmountResponse' => '\\StructType\\CancelEArchiveInvoiceStringDateAndAmountResponse',
            'SendBase64StringInvoice' => '\\StructType\\SendBase64StringInvoice',
            'SendBase64StringInvoiceResponse' => '\\StructType\\SendBase64StringInvoiceResponse',
            'SendBase64StringInvoiceWithTemplateCode' => '\\StructType\\SendBase64StringInvoiceWithTemplateCode',
            'SendBase64StringInvoiceWithTemplateCodeResponse' => '\\StructType\\SendBase64StringInvoiceWithTemplateCodeResponse',
            'SendXmlInvoice' => '\\StructType\\SendXmlInvoice',
            'SendXmlInvoiceResponse' => '\\StructType\\SendXmlInvoiceResponse',
            'SendUBLInvoice' => '\\StructType\\SendUBLInvoice',
            'SendUBLInvoiceResponse' => '\\StructType\\SendUBLInvoiceResponse',
            'UploadFromArchiveOutgoing' => '\\StructType\\UploadFromArchiveOutgoing',
            'UploadFromArchiveOutgoingResponse' => '\\StructType\\UploadFromArchiveOutgoingResponse',
            'UploadFromArchiveUBLOutgoing' => '\\StructType\\UploadFromArchiveUBLOutgoing',
            'UploadFromArchiveUBLOutgoingResponse' => '\\StructType\\UploadFromArchiveUBLOutgoingResponse',
            'UploadFromArchiveEnvelopeOutgoing' => '\\StructType\\UploadFromArchiveEnvelopeOutgoing',
            'UploadFromArchiveEnvelopeOutgoingResponse' => '\\StructType\\UploadFromArchiveEnvelopeOutgoingResponse',
            'UploadFromArchiveIncoming' => '\\StructType\\UploadFromArchiveIncoming',
            'UploadFromArchiveIncomingResponse' => '\\StructType\\UploadFromArchiveIncomingResponse',
            'UploadFromArchiveUBLIncoming' => '\\StructType\\UploadFromArchiveUBLIncoming',
            'UploadFromArchiveUBLIncomingResponse' => '\\StructType\\UploadFromArchiveUBLIncomingResponse',
            'UploadFromArchiveEnvelopeIncoming' => '\\StructType\\UploadFromArchiveEnvelopeIncoming',
            'UploadFromArchiveEnvelopeIncomingResponse' => '\\StructType\\UploadFromArchiveEnvelopeIncomingResponse',
            'SendCumulativeInvoiceData' => '\\StructType\\SendCumulativeInvoiceData',
            'SendCumulativeInvoiceDataResponse' => '\\StructType\\SendCumulativeInvoiceDataResponse',
            'ArrayOfEnvelopeStateResult' => '\\ArrayType\\ArrayOfEnvelopeStateResult',
            'CheckGibStatus' => '\\StructType\\CheckGibStatus',
            'CheckGibStatusResponse' => '\\StructType\\CheckGibStatusResponse',
            'GibStatusResult' => '\\StructType\\GibStatusResult',
            'GetEInvoiceSenderListUpdates' => '\\StructType\\GetEInvoiceSenderListUpdates',
            'GetEInvoiceSenderListUpdatesResponse' => '\\StructType\\GetEInvoiceSenderListUpdatesResponse',
            'EInvoiceCustomerListUpdateResult' => '\\StructType\\EInvoiceCustomerListUpdateResult',
            'ArrayOfEInvoiceCustomerResult' => '\\ArrayType\\ArrayOfEInvoiceCustomerResult',
            'EInvoiceCustomerResult' => '\\StructType\\EInvoiceCustomerResult',
            'GetEInvoiceReceiverListUpdates' => '\\StructType\\GetEInvoiceReceiverListUpdates',
            'GetEInvoiceReceiverListUpdatesResponse' => '\\StructType\\GetEInvoiceReceiverListUpdatesResponse',
            'AcceptInvoice' => '\\StructType\\AcceptInvoice',
            'AcceptInvoiceResponse' => '\\StructType\\AcceptInvoiceResponse',
            'ResponseResult' => '\\StructType\\ResponseResult',
            'RejectInvoice' => '\\StructType\\RejectInvoice',
            'RejectInvoiceResponse' => '\\StructType\\RejectInvoiceResponse',
            'RejectInvoiceWithNotify' => '\\StructType\\RejectInvoiceWithNotify',
            'RejectInvoiceWithNotifyResponse' => '\\StructType\\RejectInvoiceWithNotifyResponse',
            'CheckInvoiceState' => '\\StructType\\CheckInvoiceState',
            'CheckInvoiceStateResponse' => '\\StructType\\CheckInvoiceStateResponse',
            'GetAvailableInvoiceReturnStatus' => '\\StructType\\GetAvailableInvoiceReturnStatus',
            'GetAvailableInvoiceReturnStatusResponse' => '\\StructType\\GetAvailableInvoiceReturnStatusResponse',
            'GetInvoiceByInvoiceID' => '\\StructType\\GetInvoiceByInvoiceID',
            'GetInvoiceByInvoiceIDResponse' => '\\StructType\\GetInvoiceByInvoiceIDResponse',
            'InvoicePackResult' => '\\StructType\\InvoicePackResult',
            'ArrayOfInvoiceInfoResult' => '\\ArrayType\\ArrayOfInvoiceInfoResult',
            'GetInboundInvoiceByMapCode' => '\\StructType\\GetInboundInvoiceByMapCode',
            'GetInboundInvoiceByMapCodeResponse' => '\\StructType\\GetInboundInvoiceByMapCodeResponse',
            'CheckEArchiveInvoiceState' => '\\StructType\\CheckEArchiveInvoiceState',
            'CheckEArchiveInvoiceStateResponse' => '\\StructType\\CheckEArchiveInvoiceStateResponse',
            'EArchiveInvoiceStateResult' => '\\StructType\\EArchiveInvoiceStateResult',
            'CheckEArchiveReportState' => '\\StructType\\CheckEArchiveReportState',
            'CheckEArchiveReportStateResponse' => '\\StructType\\CheckEArchiveReportStateResponse',
            'EArchiveReportStateResult' => '\\StructType\\EArchiveReportStateResult',
            'DeleteEArchiveInvoice' => '\\StructType\\DeleteEArchiveInvoice',
            'DeleteEArchiveInvoiceResponse' => '\\StructType\\DeleteEArchiveInvoiceResponse',
            'DeleteEArchiveReport' => '\\StructType\\DeleteEArchiveReport',
            'DeleteEArchiveReportResponse' => '\\StructType\\DeleteEArchiveReportResponse',
            'EArchiveReportResult' => '\\StructType\\EArchiveReportResult',
            'CheckInvoiceStateWithReconciliationID' => '\\StructType\\CheckInvoiceStateWithReconciliationID',
            'CheckInvoiceStateWithReconciliationIDResponse' => '\\StructType\\CheckInvoiceStateWithReconciliationIDResponse',
            'CheckEnvelopeState' => '\\StructType\\CheckEnvelopeState',
            'CheckEnvelopeStateResponse' => '\\StructType\\CheckEnvelopeStateResponse',
            'GetEnvelope' => '\\StructType\\GetEnvelope',
            'GetEnvelopeResponse' => '\\StructType\\GetEnvelopeResponse',
            'EnvelopeDownloadResult' => '\\StructType\\EnvelopeDownloadResult',
            'GetAvailableInvoices' => '\\StructType\\GetAvailableInvoices',
            'GetAvailableInvoicesResponse' => '\\StructType\\GetAvailableInvoicesResponse',
            'GetAvailableInvoicesPW' => '\\StructType\\GetAvailableInvoicesPW',
            'GetAvailableInvoicesPWResponse' => '\\StructType\\GetAvailableInvoicesPWResponse',
            'GetAvailableCompletedInvoices' => '\\StructType\\GetAvailableCompletedInvoices',
            'GetAvailableCompletedInvoicesResponse' => '\\StructType\\GetAvailableCompletedInvoicesResponse',
            'GetAvailableInvoicesByDate' => '\\StructType\\GetAvailableInvoicesByDate',
            'GetAvailableInvoicesByDateResponse' => '\\StructType\\GetAvailableInvoicesByDateResponse',
            'GetAvailableInvoicesWithDate' => '\\StructType\\GetAvailableInvoicesWithDate',
            'GetAvailableInvoicesWithDateResponse' => '\\StructType\\GetAvailableInvoicesWithDateResponse',
            'GetIncomingInvoicesByIssueDate' => '\\StructType\\GetIncomingInvoicesByIssueDate',
            'GetIncomingInvoicesByIssueDateResponse' => '\\StructType\\GetIncomingInvoicesByIssueDateResponse',
            'GetEArchiveReportList' => '\\StructType\\GetEArchiveReportList',
            'GetEArchiveReportListResponse' => '\\StructType\\GetEArchiveReportListResponse',
            'EArchiveReportPackResult' => '\\StructType\\EArchiveReportPackResult',
            'ArrayOfEArchiveReportResult' => '\\ArrayType\\ArrayOfEArchiveReportResult',
            'GetEArchiveReportListWithPeriod' => '\\StructType\\GetEArchiveReportListWithPeriod',
            'GetEArchiveReportListWithPeriodResponse' => '\\StructType\\GetEArchiveReportListWithPeriodResponse',
            'GetInvoice' => '\\StructType\\GetInvoice',
            'GetInvoiceResponse' => '\\StructType\\GetInvoiceResponse',
            'GetInvoicePW' => '\\StructType\\GetInvoicePW',
            'GetInvoicePWResponse' => '\\StructType\\GetInvoicePWResponse',
            'GetInvoiceAllDirection' => '\\StructType\\GetInvoiceAllDirection',
            'GetInvoiceAllDirectionResponse' => '\\StructType\\GetInvoiceAllDirectionResponse',
            'GetInvoicePDF' => '\\StructType\\GetInvoicePDF',
            'GetInvoicePDFResponse' => '\\StructType\\GetInvoicePDFResponse',
            'GetInvoicePDFByInvoiceId' => '\\StructType\\GetInvoicePDFByInvoiceId',
            'GetInvoicePDFByInvoiceIdResponse' => '\\StructType\\GetInvoicePDFByInvoiceIdResponse',
            'GetInvoicePDFByInvoiceIdWithoutDirection' => '\\StructType\\GetInvoicePDFByInvoiceIdWithoutDirection',
            'GetInvoicePDFByInvoiceIdWithoutDirectionResponse' => '\\StructType\\GetInvoicePDFByInvoiceIdWithoutDirectionResponse',
            'GetInvoiceImage' => '\\StructType\\GetInvoiceImage',
            'GetInvoiceImageResponse' => '\\StructType\\GetInvoiceImageResponse',
            'GetInvoiceTemplate' => '\\StructType\\GetInvoiceTemplate',
            'GetInvoiceTemplateResponse' => '\\StructType\\GetInvoiceTemplateResponse',
            'CorporateTemplateResult' => '\\StructType\\CorporateTemplateResult',
            'GetEArchiveInvoice' => '\\StructType\\GetEArchiveInvoice',
            'GetEArchiveInvoiceResponse' => '\\StructType\\GetEArchiveInvoiceResponse',
            'GetEArchiveIncomingInvoice' => '\\StructType\\GetEArchiveIncomingInvoice',
            'GetEArchiveIncomingInvoiceResponse' => '\\StructType\\GetEArchiveIncomingInvoiceResponse',
            'GetEArchiveReport' => '\\StructType\\GetEArchiveReport',
            'GetEArchiveReportResponse' => '\\StructType\\GetEArchiveReportResponse',
            'GetInvoiceXML' => '\\StructType\\GetInvoiceXML',
            'GetInvoiceXMLResponse' => '\\StructType\\GetInvoiceXMLResponse',
            'GetInvoiceXMLWithOutFlag' => '\\StructType\\GetInvoiceXMLWithOutFlag',
            'GetInvoiceXMLWithOutFlagResponse' => '\\StructType\\GetInvoiceXMLWithOutFlagResponse',
            'GetInvoiceWithOutFlag' => '\\StructType\\GetInvoiceWithOutFlag',
            'GetInvoiceWithOutFlagResponse' => '\\StructType\\GetInvoiceWithOutFlagResponse',
            'CheckTaxIdListFromExcelFile' => '\\StructType\\CheckTaxIdListFromExcelFile',
            'CheckTaxIdListFromExcelFileResponse' => '\\StructType\\CheckTaxIdListFromExcelFileResponse',
            'EInvoiceCustomerListResult' => '\\StructType\\EInvoiceCustomerListResult',
            'CheckCustomerTaxId' => '\\StructType\\CheckCustomerTaxId',
            'CheckCustomerTaxIdResponse' => '\\StructType\\CheckCustomerTaxIdResponse',
            'CheckCustomerTaxIdbyDate' => '\\StructType\\CheckCustomerTaxIdbyDate',
            'CheckCustomerTaxIdbyDateResponse' => '\\StructType\\CheckCustomerTaxIdbyDateResponse',
            'GetTaxIdListbyDate' => '\\StructType\\GetTaxIdListbyDate',
            'GetTaxIdListbyDateResponse' => '\\StructType\\GetTaxIdListbyDateResponse',
            'GetEInvoiceCustomerListByDate' => '\\StructType\\GetEInvoiceCustomerListByDate',
            'GetEInvoiceCustomerListByDateResponse' => '\\StructType\\GetEInvoiceCustomerListByDateResponse',
            'GetEInvoiceCustomerFullList' => '\\StructType\\GetEInvoiceCustomerFullList',
            'GetEInvoiceCustomerFullListResponse' => '\\StructType\\GetEInvoiceCustomerFullListResponse',
            'EInvoiceCustomerFullListResult' => '\\StructType\\EInvoiceCustomerFullListResult',
            'GetFormsAuthenticationTicket' => '\\StructType\\GetFormsAuthenticationTicket',
            'GetFormsAuthenticationTicketResponse' => '\\StructType\\GetFormsAuthenticationTicketResponse',
            'GetFormsAuthenticationTicketPW' => '\\StructType\\GetFormsAuthenticationTicketPW',
            'GetFormsAuthenticationTicketPWResponse' => '\\StructType\\GetFormsAuthenticationTicketPWResponse',
            'CancelInvoice' => '\\StructType\\CancelInvoice',
            'CancelInvoiceResponse' => '\\StructType\\CancelInvoiceResponse',
            'ReSendInvoice' => '\\StructType\\ReSendInvoice',
            'ReSendInvoiceResponse' => '\\StructType\\ReSendInvoiceResponse',
            'GetInvoiceSummary' => '\\StructType\\GetInvoiceSummary',
            'GetInvoiceSummaryResponse' => '\\StructType\\GetInvoiceSummaryResponse',
            'InvoiceSummaryResult' => '\\StructType\\InvoiceSummaryResult',
            'ArrayOfInvoiceSummary' => '\\ArrayType\\ArrayOfInvoiceSummary',
            'InvoiceSummary' => '\\StructType\\InvoiceSummary',
            'GetInvoiceSummaryWithDate' => '\\StructType\\GetInvoiceSummaryWithDate',
            'GetInvoiceSummaryWithDateResponse' => '\\StructType\\GetInvoiceSummaryWithDateResponse',
            'GetInvoiceCountWithDate' => '\\StructType\\GetInvoiceCountWithDate',
            'GetInvoiceCountWithDateResponse' => '\\StructType\\GetInvoiceCountWithDateResponse',
            'InvoiceCountResultWithDate' => '\\StructType\\InvoiceCountResultWithDate',
            'ArrayOfInvoiceCountWithDate' => '\\ArrayType\\ArrayOfInvoiceCountWithDate',
            'InvoiceCountWithDate' => '\\StructType\\InvoiceCountWithDate',
            'GetCustomerDifferenceXml' => '\\StructType\\GetCustomerDifferenceXml',
            'GetCustomerDifferenceXmlResponse' => '\\StructType\\GetCustomerDifferenceXmlResponse',
            'CustomerInfoResult' => '\\StructType\\CustomerInfoResult',
            'GetCustomerDifferenceBase64Xml' => '\\StructType\\GetCustomerDifferenceBase64Xml',
            'GetCustomerDifferenceBase64XmlResponse' => '\\StructType\\GetCustomerDifferenceBase64XmlResponse',
            'LogServerStatus' => '\\StructType\\LogServerStatus',
            'LogServerStatusResponse' => '\\StructType\\LogServerStatusResponse',
            'ServerStatusResult' => '\\StructType\\ServerStatusResult',
            'GetAvailableSentInvoicesByDate' => '\\StructType\\GetAvailableSentInvoicesByDate',
            'GetAvailableSentInvoicesByDateResponse' => '\\StructType\\GetAvailableSentInvoicesByDateResponse',
            'GetAvailableSentInvoicesByIssueDate' => '\\StructType\\GetAvailableSentInvoicesByIssueDate',
            'GetAvailableSentInvoicesByIssueDateResponse' => '\\StructType\\GetAvailableSentInvoicesByIssueDateResponse',
            'ProcessDataWithCode' => '\\StructType\\ProcessDataWithCode',
            'ProcessDataWithCodeResponse' => '\\StructType\\ProcessDataWithCodeResponse',
            'DBJobProcessResult' => '\\StructType\\DBJobProcessResult',
            'ArrayOfInvoiceIDRecordResult' => '\\ArrayType\\ArrayOfInvoiceIDRecordResult',
            'InvoiceIDRecordResult' => '\\StructType\\InvoiceIDRecordResult',
            'GetHashOfInvoice' => '\\StructType\\GetHashOfInvoice',
            'GetHashOfInvoiceResponse' => '\\StructType\\GetHashOfInvoiceResponse',
            'GetHashOfInvoiceResult' => '\\StructType\\GetHashOfInvoiceResult',
            'GetEArchiveInvoicesByDate' => '\\StructType\\GetEArchiveInvoicesByDate',
            'GetEArchiveInvoicesByDateResponse' => '\\StructType\\GetEArchiveInvoicesByDateResponse',
            'GetEArchiveInvoicesWithDate' => '\\StructType\\GetEArchiveInvoicesWithDate',
            'GetEArchiveInvoicesWithDateResponse' => '\\StructType\\GetEArchiveInvoicesWithDateResponse',
            'GetEArchiveInvoicesWithIssueDateAndTaxNumber' => '\\StructType\\GetEArchiveInvoicesWithIssueDateAndTaxNumber',
            'GetEArchiveInvoicesWithIssueDateAndTaxNumberResponse' => '\\StructType\\GetEArchiveInvoicesWithIssueDateAndTaxNumberResponse',
            'GetInvoiceHTML' => '\\StructType\\GetInvoiceHTML',
            'GetInvoiceHTMLResponse' => '\\StructType\\GetInvoiceHTMLResponse',
            'GetEArchiveInvoicesByReportNo' => '\\StructType\\GetEArchiveInvoicesByReportNo',
            'GetEArchiveInvoicesByReportNoResponse' => '\\StructType\\GetEArchiveInvoicesByReportNoResponse',
            'SendInvoiceAsEmail' => '\\StructType\\SendInvoiceAsEmail',
            'SendInvoiceAsEmailResponse' => '\\StructType\\SendInvoiceAsEmailResponse',
            'SendEMailResult' => '\\StructType\\SendEMailResult',
            'GetNewInvoiceId' => '\\StructType\\GetNewInvoiceId',
            'GetNewInvoiceIdResponse' => '\\StructType\\GetNewInvoiceIdResponse',
            'InvoiceIdResult' => '\\StructType\\InvoiceIdResult',
            'GetReconciliationEArchiveByDate' => '\\StructType\\GetReconciliationEArchiveByDate',
            'ArrayOfEArchiveReconciliationInvoices' => '\\ArrayType\\ArrayOfEArchiveReconciliationInvoices',
            'eArchiveReconciliationInvoices' => '\\StructType\\EArchiveReconciliationInvoices',
            'GetReconciliationEArchiveByDateResponse' => '\\StructType\\GetReconciliationEArchiveByDateResponse',
            'eArchiveReconciliationPackResult' => '\\StructType\\EArchiveReconciliationPackResult',
            'GetReconciliationEArchiveByDateExtended' => '\\StructType\\GetReconciliationEArchiveByDateExtended',
            'GetReconciliationEArchiveByDateExtendedResponse' => '\\StructType\\GetReconciliationEArchiveByDateExtendedResponse',
            'GetGTBRefAndRegisterNumber' => '\\StructType\\GetGTBRefAndRegisterNumber',
            'GetGTBRefAndRegisterNumberResponse' => '\\StructType\\GetGTBRefAndRegisterNumberResponse',
            'GTBRefAndRegNoResult' => '\\StructType\\GTBRefAndRegNoResult',
            'SendTaxFreeInvoiceData' => '\\StructType\\SendTaxFreeInvoiceData',
            'SendTaxFreeInvoiceDataResponse' => '\\StructType\\SendTaxFreeInvoiceDataResponse',
            'CancelInvoiceDataForTaxFree' => '\\StructType\\CancelInvoiceDataForTaxFree',
            'CancelInvoiceDataForTaxFreeResponse' => '\\StructType\\CancelInvoiceDataForTaxFreeResponse',
            'UploadFromArchiveEArchive' => '\\StructType\\UploadFromArchiveEArchive',
            'UploadFromArchiveEArchiveResponse' => '\\StructType\\UploadFromArchiveEArchiveResponse',
            'UploadFromArchiveEArchiveReport' => '\\StructType\\UploadFromArchiveEArchiveReport',
            'UploadFromArchiveEArchiveReportResponse' => '\\StructType\\UploadFromArchiveEArchiveReportResponse',
            'GetIncomingInvoiceBranchInfo' => '\\StructType\\GetIncomingInvoiceBranchInfo',
            'ArrayOfInvoiceInfoQuery' => '\\ArrayType\\ArrayOfInvoiceInfoQuery',
            'InvoiceInfoQuery' => '\\StructType\\InvoiceInfoQuery',
            'GetIncomingInvoiceBranchInfoResponse' => '\\StructType\\GetIncomingInvoiceBranchInfoResponse',
            'InvoicesInfoResult' => '\\StructType\\InvoicesInfoResult',
            'ArrayOfInvoiceInfoList' => '\\ArrayType\\ArrayOfInvoiceInfoList',
            'InvoiceInfoList' => '\\StructType\\InvoiceInfoList',
            'UpdateEnvelopeStatusFromGib' => '\\StructType\\UpdateEnvelopeStatusFromGib',
            'UpdateEnvelopeStatusFromGibResponse' => '\\StructType\\UpdateEnvelopeStatusFromGibResponse',
            'OutSidersSendEmail' => '\\StructType\\OutSidersSendEmail',
            'OutsiderMailMessage' => '\\StructType\\OutsiderMailMessage',
            'ArrayOfOutSiderMailMessageAttach' => '\\ArrayType\\ArrayOfOutSiderMailMessageAttach',
            'OutSiderMailMessageAttach' => '\\StructType\\OutSiderMailMessageAttach',
            'OutSidersSendEmailResponse' => '\\StructType\\OutSidersSendEmailResponse',
            'OutSidersEMailResult' => '\\StructType\\OutSidersEMailResult',
            'PartnerAndCorporateContourInfo' => '\\StructType\\PartnerAndCorporateContourInfo',
            'PartnerAndCorporateContourInfoResponse' => '\\StructType\\PartnerAndCorporateContourInfoResponse',
            'ContourInfoListResult' => '\\StructType\\ContourInfoListResult',
            'ArrayOfContourInfo' => '\\ArrayType\\ArrayOfContourInfo',
            'ContourInfo' => '\\StructType\\ContourInfo',
            'CorporateContourInfo' => '\\StructType\\CorporateContourInfo',
            'CorporateContourInfoResponse' => '\\StructType\\CorporateContourInfoResponse',
            'UsingCountsForPartner' => '\\StructType\\UsingCountsForPartner',
            'UsingCountsForPartnerResponse' => '\\StructType\\UsingCountsForPartnerResponse',
            'PartnerUsingCountsResults' => '\\StructType\\PartnerUsingCountsResults',
            'ArrayOfOutgoingInvoiceCount' => '\\ArrayType\\ArrayOfOutgoingInvoiceCount',
            'OutgoingInvoiceCount' => '\\StructType\\OutgoingInvoiceCount',
            'PartnerUsingCountBaseClass' => '\\StructType\\PartnerUsingCountBaseClass',
            'ProducersReceiptCount' => '\\StructType\\ProducersReceiptCount',
            'ProducersSevoucherCount' => '\\StructType\\ProducersSevoucherCount',
            'IncomingDespatchAdviceCount' => '\\StructType\\IncomingDespatchAdviceCount',
            'OutgoingDespatchAdviceCount' => '\\StructType\\OutgoingDespatchAdviceCount',
            'EarchiveInvoiceCount' => '\\StructType\\EarchiveInvoiceCount',
            'IncomingInvoiceCount' => '\\StructType\\IncomingInvoiceCount',
            'ArrayOfIncomingInvoiceCount' => '\\ArrayType\\ArrayOfIncomingInvoiceCount',
            'ArrayOfEarchiveInvoiceCount' => '\\ArrayType\\ArrayOfEarchiveInvoiceCount',
            'ArrayOfOutgoingDespatchAdviceCount' => '\\ArrayType\\ArrayOfOutgoingDespatchAdviceCount',
            'ArrayOfIncomingDespatchAdviceCount' => '\\ArrayType\\ArrayOfIncomingDespatchAdviceCount',
            'ArrayOfProducersSevoucherCount' => '\\ArrayType\\ArrayOfProducersSevoucherCount',
            'ArrayOfProducersReceiptCount' => '\\ArrayType\\ArrayOfProducersReceiptCount',
        );
    }
}
