<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelEArchiveInvoiceStringDateAndAmount StructType
 * @subpackage Structs
 */
class CancelEArchiveInvoiceStringDateAndAmount extends AbstractStructBase
{
    /**
     * The Ticket
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ticket;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Value;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The TotalAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TotalAmount;
    /**
     * The CancelDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CancelDate;
    /**
     * Constructor method for CancelEArchiveInvoiceStringDateAndAmount
     * @uses CancelEArchiveInvoiceStringDateAndAmount::setTicket()
     * @uses CancelEArchiveInvoiceStringDateAndAmount::setValue()
     * @uses CancelEArchiveInvoiceStringDateAndAmount::setType()
     * @uses CancelEArchiveInvoiceStringDateAndAmount::setTotalAmount()
     * @uses CancelEArchiveInvoiceStringDateAndAmount::setCancelDate()
     * @param string $ticket
     * @param string $value
     * @param string $type
     * @param string $totalAmount
     * @param string $cancelDate
     */
    public function __construct($ticket = null, $value = null, $type = null, $totalAmount = null, $cancelDate = null)
    {
        $this
            ->setTicket($ticket)
            ->setValue($value)
            ->setType($type)
            ->setTotalAmount($totalAmount)
            ->setCancelDate($cancelDate);
    }
    /**
     * Get Ticket value
     * @return string|null
     */
    public function getTicket()
    {
        return $this->Ticket;
    }
    /**
     * Set Ticket value
     * @param string $ticket
     * @return \StructType\CancelEArchiveInvoiceStringDateAndAmount
     */
    public function setTicket($ticket = null)
    {
        // validation for constraint: string
        if (!is_null($ticket) && !is_string($ticket)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ticket, true), gettype($ticket)), __LINE__);
        }
        $this->Ticket = $ticket;
        return $this;
    }
    /**
     * Get Value value
     * @return string|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param string $value
     * @return \StructType\CancelEArchiveInvoiceStringDateAndAmount
     */
    public function setValue($value = null)
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->Value = $value;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\CancelEArchiveInvoiceStringDateAndAmount
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get TotalAmount value
     * @return string|null
     */
    public function getTotalAmount()
    {
        return $this->TotalAmount;
    }
    /**
     * Set TotalAmount value
     * @param string $totalAmount
     * @return \StructType\CancelEArchiveInvoiceStringDateAndAmount
     */
    public function setTotalAmount($totalAmount = null)
    {
        // validation for constraint: string
        if (!is_null($totalAmount) && !is_string($totalAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($totalAmount, true), gettype($totalAmount)), __LINE__);
        }
        $this->TotalAmount = $totalAmount;
        return $this;
    }
    /**
     * Get CancelDate value
     * @return string|null
     */
    public function getCancelDate()
    {
        return $this->CancelDate;
    }
    /**
     * Set CancelDate value
     * @param string $cancelDate
     * @return \StructType\CancelEArchiveInvoiceStringDateAndAmount
     */
    public function setCancelDate($cancelDate = null)
    {
        // validation for constraint: string
        if (!is_null($cancelDate) && !is_string($cancelDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cancelDate, true), gettype($cancelDate)), __LINE__);
        }
        $this->CancelDate = $cancelDate;
        return $this;
    }
}
