<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EInvoiceCustomerResult StructType
 * @subpackage Structs
 */
class EInvoiceCustomerResult extends AbstractStructBase
{
    /**
     * The RegisterTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $RegisterTime;
    /**
     * The IsExist
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsExist;
    /**
     * The AliasCreateDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $AliasCreateDate;
    /**
     * The FirstCreationTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $FirstCreationTime;
    /**
     * The TaxIdOrPersonalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TaxIdOrPersonalId;
    /**
     * The Alias
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Alias;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * Constructor method for EInvoiceCustomerResult
     * @uses EInvoiceCustomerResult::setRegisterTime()
     * @uses EInvoiceCustomerResult::setIsExist()
     * @uses EInvoiceCustomerResult::setAliasCreateDate()
     * @uses EInvoiceCustomerResult::setFirstCreationTime()
     * @uses EInvoiceCustomerResult::setTaxIdOrPersonalId()
     * @uses EInvoiceCustomerResult::setAlias()
     * @uses EInvoiceCustomerResult::setType()
     * @uses EInvoiceCustomerResult::setName()
     * @param string $registerTime
     * @param bool $isExist
     * @param string $aliasCreateDate
     * @param string $firstCreationTime
     * @param string $taxIdOrPersonalId
     * @param string $alias
     * @param string $type
     * @param string $name
     */
    public function __construct($registerTime = null, $isExist = null, $aliasCreateDate = null, $firstCreationTime = null, $taxIdOrPersonalId = null, $alias = null, $type = null, $name = null)
    {
        $this
            ->setRegisterTime($registerTime)
            ->setIsExist($isExist)
            ->setAliasCreateDate($aliasCreateDate)
            ->setFirstCreationTime($firstCreationTime)
            ->setTaxIdOrPersonalId($taxIdOrPersonalId)
            ->setAlias($alias)
            ->setType($type)
            ->setName($name);
    }
    /**
     * Get RegisterTime value
     * @return string
     */
    public function getRegisterTime()
    {
        return $this->RegisterTime;
    }
    /**
     * Set RegisterTime value
     * @param string $registerTime
     * @return \StructType\EInvoiceCustomerResult
     */
    public function setRegisterTime($registerTime = null)
    {
        // validation for constraint: string
        if (!is_null($registerTime) && !is_string($registerTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registerTime, true), gettype($registerTime)), __LINE__);
        }
        $this->RegisterTime = $registerTime;
        return $this;
    }
    /**
     * Get IsExist value
     * @return bool
     */
    public function getIsExist()
    {
        return $this->IsExist;
    }
    /**
     * Set IsExist value
     * @param bool $isExist
     * @return \StructType\EInvoiceCustomerResult
     */
    public function setIsExist($isExist = null)
    {
        // validation for constraint: boolean
        if (!is_null($isExist) && !is_bool($isExist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isExist, true), gettype($isExist)), __LINE__);
        }
        $this->IsExist = $isExist;
        return $this;
    }
    /**
     * Get AliasCreateDate value
     * @return string
     */
    public function getAliasCreateDate()
    {
        return $this->AliasCreateDate;
    }
    /**
     * Set AliasCreateDate value
     * @param string $aliasCreateDate
     * @return \StructType\EInvoiceCustomerResult
     */
    public function setAliasCreateDate($aliasCreateDate = null)
    {
        // validation for constraint: string
        if (!is_null($aliasCreateDate) && !is_string($aliasCreateDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aliasCreateDate, true), gettype($aliasCreateDate)), __LINE__);
        }
        $this->AliasCreateDate = $aliasCreateDate;
        return $this;
    }
    /**
     * Get FirstCreationTime value
     * @return string
     */
    public function getFirstCreationTime()
    {
        return $this->FirstCreationTime;
    }
    /**
     * Set FirstCreationTime value
     * @param string $firstCreationTime
     * @return \StructType\EInvoiceCustomerResult
     */
    public function setFirstCreationTime($firstCreationTime = null)
    {
        // validation for constraint: string
        if (!is_null($firstCreationTime) && !is_string($firstCreationTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstCreationTime, true), gettype($firstCreationTime)), __LINE__);
        }
        $this->FirstCreationTime = $firstCreationTime;
        return $this;
    }
    /**
     * Get TaxIdOrPersonalId value
     * @return string|null
     */
    public function getTaxIdOrPersonalId()
    {
        return $this->TaxIdOrPersonalId;
    }
    /**
     * Set TaxIdOrPersonalId value
     * @param string $taxIdOrPersonalId
     * @return \StructType\EInvoiceCustomerResult
     */
    public function setTaxIdOrPersonalId($taxIdOrPersonalId = null)
    {
        // validation for constraint: string
        if (!is_null($taxIdOrPersonalId) && !is_string($taxIdOrPersonalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($taxIdOrPersonalId, true), gettype($taxIdOrPersonalId)), __LINE__);
        }
        $this->TaxIdOrPersonalId = $taxIdOrPersonalId;
        return $this;
    }
    /**
     * Get Alias value
     * @return string|null
     */
    public function getAlias()
    {
        return $this->Alias;
    }
    /**
     * Set Alias value
     * @param string $alias
     * @return \StructType\EInvoiceCustomerResult
     */
    public function setAlias($alias = null)
    {
        // validation for constraint: string
        if (!is_null($alias) && !is_string($alias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($alias, true), gettype($alias)), __LINE__);
        }
        $this->Alias = $alias;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\EInvoiceCustomerResult
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\EInvoiceCustomerResult
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
}
