<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendBase64StringEArchiveData StructType
 * @subpackage Structs
 */
class SendBase64StringEArchiveData extends AbstractStructBase
{
    /**
     * The Ticket
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ticket;
    /**
     * The FileType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FileType;
    /**
     * The InvoiceRawData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InvoiceRawData;
    /**
     * The CorporateCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CorporateCode;
    /**
     * The MapCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MapCode;
    /**
     * Constructor method for SendBase64StringEArchiveData
     * @uses SendBase64StringEArchiveData::setTicket()
     * @uses SendBase64StringEArchiveData::setFileType()
     * @uses SendBase64StringEArchiveData::setInvoiceRawData()
     * @uses SendBase64StringEArchiveData::setCorporateCode()
     * @uses SendBase64StringEArchiveData::setMapCode()
     * @param string $ticket
     * @param string $fileType
     * @param string $invoiceRawData
     * @param string $corporateCode
     * @param string $mapCode
     */
    public function __construct($ticket = null, $fileType = null, $invoiceRawData = null, $corporateCode = null, $mapCode = null)
    {
        $this
            ->setTicket($ticket)
            ->setFileType($fileType)
            ->setInvoiceRawData($invoiceRawData)
            ->setCorporateCode($corporateCode)
            ->setMapCode($mapCode);
    }
    /**
     * Get Ticket value
     * @return string|null
     */
    public function getTicket()
    {
        return $this->Ticket;
    }
    /**
     * Set Ticket value
     * @param string $ticket
     * @return \StructType\SendBase64StringEArchiveData
     */
    public function setTicket($ticket = null)
    {
        // validation for constraint: string
        if (!is_null($ticket) && !is_string($ticket)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ticket, true), gettype($ticket)), __LINE__);
        }
        $this->Ticket = $ticket;
        return $this;
    }
    /**
     * Get FileType value
     * @return string|null
     */
    public function getFileType()
    {
        return $this->FileType;
    }
    /**
     * Set FileType value
     * @param string $fileType
     * @return \StructType\SendBase64StringEArchiveData
     */
    public function setFileType($fileType = null)
    {
        // validation for constraint: string
        if (!is_null($fileType) && !is_string($fileType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fileType, true), gettype($fileType)), __LINE__);
        }
        $this->FileType = $fileType;
        return $this;
    }
    /**
     * Get InvoiceRawData value
     * @return string|null
     */
    public function getInvoiceRawData()
    {
        return $this->InvoiceRawData;
    }
    /**
     * Set InvoiceRawData value
     * @param string $invoiceRawData
     * @return \StructType\SendBase64StringEArchiveData
     */
    public function setInvoiceRawData($invoiceRawData = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceRawData) && !is_string($invoiceRawData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceRawData, true), gettype($invoiceRawData)), __LINE__);
        }
        $this->InvoiceRawData = $invoiceRawData;
        return $this;
    }
    /**
     * Get CorporateCode value
     * @return string|null
     */
    public function getCorporateCode()
    {
        return $this->CorporateCode;
    }
    /**
     * Set CorporateCode value
     * @param string $corporateCode
     * @return \StructType\SendBase64StringEArchiveData
     */
    public function setCorporateCode($corporateCode = null)
    {
        // validation for constraint: string
        if (!is_null($corporateCode) && !is_string($corporateCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($corporateCode, true), gettype($corporateCode)), __LINE__);
        }
        $this->CorporateCode = $corporateCode;
        return $this;
    }
    /**
     * Get MapCode value
     * @return string|null
     */
    public function getMapCode()
    {
        return $this->MapCode;
    }
    /**
     * Set MapCode value
     * @param string $mapCode
     * @return \StructType\SendBase64StringEArchiveData
     */
    public function setMapCode($mapCode = null)
    {
        // validation for constraint: string
        if (!is_null($mapCode) && !is_string($mapCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mapCode, true), gettype($mapCode)), __LINE__);
        }
        $this->MapCode = $mapCode;
        return $this;
    }
}
