<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendEArchiveDataWithTemplateCode StructType
 * @subpackage Structs
 */
class SendEArchiveDataWithTemplateCode extends AbstractStructBase
{
    /**
     * The FileType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $FileType;
    /**
     * The Ticket
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ticket;
    /**
     * The InvoiceRawData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InvoiceRawData;
    /**
     * The CorporateCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CorporateCode;
    /**
     * The MapCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MapCode;
    /**
     * The TemplateCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateCode;
    /**
     * Constructor method for SendEArchiveDataWithTemplateCode
     * @uses SendEArchiveDataWithTemplateCode::setFileType()
     * @uses SendEArchiveDataWithTemplateCode::setTicket()
     * @uses SendEArchiveDataWithTemplateCode::setInvoiceRawData()
     * @uses SendEArchiveDataWithTemplateCode::setCorporateCode()
     * @uses SendEArchiveDataWithTemplateCode::setMapCode()
     * @uses SendEArchiveDataWithTemplateCode::setTemplateCode()
     * @param string $fileType
     * @param string $ticket
     * @param string $invoiceRawData
     * @param string $corporateCode
     * @param string $mapCode
     * @param string $templateCode
     */
    public function __construct($fileType = null, $ticket = null, $invoiceRawData = null, $corporateCode = null, $mapCode = null, $templateCode = null)
    {
        $this
            ->setFileType($fileType)
            ->setTicket($ticket)
            ->setInvoiceRawData($invoiceRawData)
            ->setCorporateCode($corporateCode)
            ->setMapCode($mapCode)
            ->setTemplateCode($templateCode);
    }
    /**
     * Get FileType value
     * @return string
     */
    public function getFileType()
    {
        return $this->FileType;
    }
    /**
     * Set FileType value
     * @uses \EnumType\File::valueIsValid()
     * @uses \EnumType\File::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $fileType
     * @return \StructType\SendEArchiveDataWithTemplateCode
     */
    public function setFileType($fileType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\File::valueIsValid($fileType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\File', is_array($fileType) ? implode(', ', $fileType) : var_export($fileType, true), implode(', ', \EnumType\File::getValidValues())), __LINE__);
        }
        $this->FileType = $fileType;
        return $this;
    }
    /**
     * Get Ticket value
     * @return string|null
     */
    public function getTicket()
    {
        return $this->Ticket;
    }
    /**
     * Set Ticket value
     * @param string $ticket
     * @return \StructType\SendEArchiveDataWithTemplateCode
     */
    public function setTicket($ticket = null)
    {
        // validation for constraint: string
        if (!is_null($ticket) && !is_string($ticket)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ticket, true), gettype($ticket)), __LINE__);
        }
        $this->Ticket = $ticket;
        return $this;
    }
    /**
     * Get InvoiceRawData value
     * @return string|null
     */
    public function getInvoiceRawData()
    {
        return $this->InvoiceRawData;
    }
    /**
     * Set InvoiceRawData value
     * @param string $invoiceRawData
     * @return \StructType\SendEArchiveDataWithTemplateCode
     */
    public function setInvoiceRawData($invoiceRawData = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceRawData) && !is_string($invoiceRawData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceRawData, true), gettype($invoiceRawData)), __LINE__);
        }
        $this->InvoiceRawData = $invoiceRawData;
        return $this;
    }
    /**
     * Get CorporateCode value
     * @return string|null
     */
    public function getCorporateCode()
    {
        return $this->CorporateCode;
    }
    /**
     * Set CorporateCode value
     * @param string $corporateCode
     * @return \StructType\SendEArchiveDataWithTemplateCode
     */
    public function setCorporateCode($corporateCode = null)
    {
        // validation for constraint: string
        if (!is_null($corporateCode) && !is_string($corporateCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($corporateCode, true), gettype($corporateCode)), __LINE__);
        }
        $this->CorporateCode = $corporateCode;
        return $this;
    }
    /**
     * Get MapCode value
     * @return string|null
     */
    public function getMapCode()
    {
        return $this->MapCode;
    }
    /**
     * Set MapCode value
     * @param string $mapCode
     * @return \StructType\SendEArchiveDataWithTemplateCode
     */
    public function setMapCode($mapCode = null)
    {
        // validation for constraint: string
        if (!is_null($mapCode) && !is_string($mapCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mapCode, true), gettype($mapCode)), __LINE__);
        }
        $this->MapCode = $mapCode;
        return $this;
    }
    /**
     * Get TemplateCode value
     * @return string|null
     */
    public function getTemplateCode()
    {
        return $this->TemplateCode;
    }
    /**
     * Set TemplateCode value
     * @param string $templateCode
     * @return \StructType\SendEArchiveDataWithTemplateCode
     */
    public function setTemplateCode($templateCode = null)
    {
        // validation for constraint: string
        if (!is_null($templateCode) && !is_string($templateCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateCode, true), gettype($templateCode)), __LINE__);
        }
        $this->TemplateCode = $templateCode;
        return $this;
    }
}
