<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UploadFromArchiveIncoming StructType
 * @subpackage Structs
 */
class UploadFromArchiveIncoming extends AbstractStructBase
{
    /**
     * The Ticket
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ticket;
    /**
     * The data
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $data;
    /**
     * The instanceidentifier
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $instanceidentifier;
    /**
     * The CorporateCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CorporateCode;
    /**
     * Constructor method for UploadFromArchiveIncoming
     * @uses UploadFromArchiveIncoming::setTicket()
     * @uses UploadFromArchiveIncoming::setData()
     * @uses UploadFromArchiveIncoming::setInstanceidentifier()
     * @uses UploadFromArchiveIncoming::setCorporateCode()
     * @param string $ticket
     * @param string $data
     * @param string $instanceidentifier
     * @param string $corporateCode
     */
    public function __construct($ticket = null, $data = null, $instanceidentifier = null, $corporateCode = null)
    {
        $this
            ->setTicket($ticket)
            ->setData($data)
            ->setInstanceidentifier($instanceidentifier)
            ->setCorporateCode($corporateCode);
    }
    /**
     * Get Ticket value
     * @return string|null
     */
    public function getTicket()
    {
        return $this->Ticket;
    }
    /**
     * Set Ticket value
     * @param string $ticket
     * @return \StructType\UploadFromArchiveIncoming
     */
    public function setTicket($ticket = null)
    {
        // validation for constraint: string
        if (!is_null($ticket) && !is_string($ticket)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ticket, true), gettype($ticket)), __LINE__);
        }
        $this->Ticket = $ticket;
        return $this;
    }
    /**
     * Get data value
     * @return string|null
     */
    public function getData()
    {
        return $this->data;
    }
    /**
     * Set data value
     * @param string $data
     * @return \StructType\UploadFromArchiveIncoming
     */
    public function setData($data = null)
    {
        // validation for constraint: string
        if (!is_null($data) && !is_string($data)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($data, true), gettype($data)), __LINE__);
        }
        $this->data = $data;
        return $this;
    }
    /**
     * Get instanceidentifier value
     * @return string|null
     */
    public function getInstanceidentifier()
    {
        return $this->instanceidentifier;
    }
    /**
     * Set instanceidentifier value
     * @param string $instanceidentifier
     * @return \StructType\UploadFromArchiveIncoming
     */
    public function setInstanceidentifier($instanceidentifier = null)
    {
        // validation for constraint: string
        if (!is_null($instanceidentifier) && !is_string($instanceidentifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($instanceidentifier, true), gettype($instanceidentifier)), __LINE__);
        }
        $this->instanceidentifier = $instanceidentifier;
        return $this;
    }
    /**
     * Get CorporateCode value
     * @return string|null
     */
    public function getCorporateCode()
    {
        return $this->CorporateCode;
    }
    /**
     * Set CorporateCode value
     * @param string $corporateCode
     * @return \StructType\UploadFromArchiveIncoming
     */
    public function setCorporateCode($corporateCode = null)
    {
        // validation for constraint: string
        if (!is_null($corporateCode) && !is_string($corporateCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($corporateCode, true), gettype($corporateCode)), __LINE__);
        }
        $this->CorporateCode = $corporateCode;
        return $this;
    }
}
